Index: boot/arch/arm32/Makefile.inc
===================================================================
--- boot/arch/arm32/Makefile.inc	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ boot/arch/arm32/Makefile.inc	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -49,5 +49,4 @@
 SOURCES = \
 	arch/$(BARCH)/src/asm.S \
-	arch/$(BARCH)/src/eabi.S \
 	arch/$(BARCH)/src/main.c \
 	arch/$(BARCH)/src/mm.c \
Index: boot/genarch/include/division.h
===================================================================
--- boot/genarch/include/division.h	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ boot/genarch/include/division.h	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -33,20 +33,28 @@
 #define BOOT_DIVISION_H_
 
+/* 32bit integer division */
 extern int __divsi3(int, int);
+
+/* 64bit integer division */
 extern long long __divdi3(long long, long long);
 
+/* 32bit unsigned integer division */
 extern unsigned int __udivsi3(unsigned int, unsigned int);
+
+/* 64bit unsigned integer division */
 extern unsigned long long __udivdi3(unsigned long long, unsigned long long);
 
+/* 32bit remainder of the signed division */
 extern int __modsi3(int, int);
+
+/* 64bit remainder of the signed division */
 extern long long __moddi3(long long, long long);
 
+/* 32bit remainder of the unsigned division */
 extern unsigned int __umodsi3(unsigned int, unsigned int);
+
+/* 64bit remainder of the unsigned division */
 extern unsigned long long __umoddi3(unsigned long long, unsigned long long);
 
-extern int __divmodsi3(int, int, int *);
-extern unsigned int __udivmodsi3(unsigned int, unsigned int, unsigned int *);
-
-extern long long __divmoddi3(long long, long long, long long *);
 extern unsigned long long __udivmoddi3(unsigned long long, unsigned long long,
     unsigned long long *);
Index: boot/genarch/src/division.c
===================================================================
--- boot/genarch/src/division.c	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ boot/genarch/src/division.c	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -73,5 +73,5 @@
 {
 	unsigned long long result;
-	int steps = sizeof(unsigned long long) * 8;
+	int steps = sizeof(unsigned long long) * 8; 
 	
 	*remainder = 0;
@@ -104,5 +104,5 @@
 
 /* 32bit integer division */
-int __divsi3(int a, int b)
+int __divsi3(int a, int b) 
 {
 	unsigned int rem;
@@ -116,5 +116,5 @@
 
 /* 64bit integer division */
-long long __divdi3(long long a, long long b)
+long long __divdi3(long long a, long long b) 
 {
 	unsigned long long rem;
@@ -155,5 +155,5 @@
 
 /* 64bit remainder of the signed division */
-long long __moddi3(long long a, long long b)
+long long __moddi3(long long a,long  long b)
 {
 	unsigned long long rem;
@@ -183,38 +183,4 @@
 }
 
-int __divmodsi3(int a, int b, int *c)
-{
-	unsigned int rem;
-	int result = (int) divandmod32(ABSVAL(a), ABSVAL(b), &rem);
-	
-	if (SGN(a) == SGN(b)) {
-		*c = rem;
-		return result;
-	}
-	
-	*c = -rem;
-	return -result;
-}
-
-unsigned int __udivmodsi3(unsigned int a, unsigned int b,
-    unsigned int *c)
-{
-	return divandmod32(a, b, c);
-}
-
-long long __divmoddi3(long long a, long long b, long long *c)
-{
-	unsigned long long rem;
-	long long result = (int) divandmod64(ABSVAL(a), ABSVAL(b), &rem);
-	
-	if (SGN(a) == SGN(b)) {
-		*c = rem;
-		return result;
-	}
-	
-	*c = -rem;
-	return -result;
-}
-
 unsigned long long __udivmoddi3(unsigned long long a, unsigned long long b,
     unsigned long long *c)
Index: boot/generic/src/str.c
===================================================================
--- boot/generic/src/str.c	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ boot/generic/src/str.c	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -100,11 +100,4 @@
 #include <str.h>
 #include <errno.h>
-
-/** Check the condition if wchar_t is signed */
-#ifdef WCHAR_IS_UNSIGNED
-	#define WCHAR_SIGNED_CHECK(cond)  (true)
-#else
-	#define WCHAR_SIGNED_CHECK(cond)  (cond)
-#endif
 
 /** Byte mask consisting of lowest @n bits (out of 8) */
@@ -205,5 +198,5 @@
  *         code was invalid.
  */
-int chr_encode(const wchar_t ch, char *str, size_t *offset, size_t size)
+int chr_encode(wchar_t ch, char *str, size_t *offset, size_t size)
 {
 	if (*offset >= size)
@@ -332,5 +325,5 @@
 bool ascii_check(wchar_t ch)
 {
-	if (WCHAR_SIGNED_CHECK(ch >= 0) && (ch <= 127))
+	if ((ch >= 0) && (ch <= 127))
 		return true;
 	
@@ -345,5 +338,5 @@
 bool chr_check(wchar_t ch)
 {
-	if (WCHAR_SIGNED_CHECK(ch >= 0) && (ch <= 1114111))
+	if ((ch >= 0) && (ch <= 1114111))
 		return true;
 	
Index: kernel/arch/arm32/Makefile.inc
===================================================================
--- kernel/arch/arm32/Makefile.inc	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ kernel/arch/arm32/Makefile.inc	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -41,5 +41,4 @@
 	arch/$(KARCH)/src/start.S \
 	arch/$(KARCH)/src/asm.S \
-	arch/$(KARCH)/src/eabi.S \
 	arch/$(KARCH)/src/exc_handler.S \
 	arch/$(KARCH)/src/arm32.c \
Index: kernel/genarch/include/softint/division.h
===================================================================
--- kernel/genarch/include/softint/division.h	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ kernel/genarch/include/softint/division.h	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -36,22 +36,29 @@
 #define KERN_DIVISION_H_
 
-extern int __divsi3(int, int);
-extern long long __divdi3(long long, long long);
+/* 32bit integer division */
+int __divsi3(int a, int b);
 
-extern unsigned int __udivsi3(unsigned int, unsigned int);
-extern unsigned long long __udivdi3(unsigned long long, unsigned long long);
+/* 64bit integer division */
+long long __divdi3(long long a, long long b);
 
-extern int __modsi3(int, int);
-extern long long __moddi3(long long, long long);
+/* 32bit unsigned integer division */
+unsigned int __udivsi3(unsigned int a, unsigned int b);
 
-extern unsigned int __umodsi3(unsigned int, unsigned int);
-extern unsigned long long __umoddi3(unsigned long long, unsigned long long);
+/* 64bit unsigned integer division */
+unsigned long long __udivdi3(unsigned long long a, unsigned long long b);
 
-extern int __divmodsi3(int, int, int *);
-extern unsigned int __udivmodsi3(unsigned int, unsigned int, unsigned int *);
+/* 32bit remainder of the signed division */
+int __modsi3(int a, int b);
 
-extern long long __divmoddi3(long long, long long, long long *);
-extern unsigned long long __udivmoddi3(unsigned long long, unsigned long long,
-    unsigned long long *);
+/* 64bit remainder of the signed division */
+long long __moddi3(long long a, long long b);
+
+/* 32bit remainder of the unsigned division */
+unsigned int __umodsi3(unsigned int a, unsigned int b);
+
+/* 64bit remainder of the unsigned division */
+unsigned long long __umoddi3(unsigned long long a, unsigned long long b);
+
+unsigned long long __udivmoddi3(unsigned long long a, unsigned long long b, unsigned long long *c); 
 
 #endif
Index: kernel/genarch/include/softint/multiplication.h
===================================================================
--- kernel/genarch/include/softint/multiplication.h	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ kernel/genarch/include/softint/multiplication.h	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -29,14 +29,14 @@
 /** @addtogroup genarch
  * @{
- */
+ */ 
 /**
  * @file
  */
 
-#ifndef KERN_MULTIPLICATION_H_
-#define KERN_MULTIPLICATION_H_
+#ifndef __SOFTINT_MULTIPLICATION_H__
+#define __SOFTINT_MULTIPLICATION_H__
 
 /* 64 bit multiplication */
-extern long long __muldi3(long long, long long);
+long long __muldi3(long long a, long long b);
 
 #endif
@@ -44,2 +44,4 @@
 /** @}
  */
+
+
Index: kernel/genarch/src/softint/division.c
===================================================================
--- kernel/genarch/src/softint/division.c	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ kernel/genarch/src/softint/division.c	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -27,5 +27,5 @@
  */
 
-/** @addtogroup genarch
+/** @addtogroup genarch	
  * @{
  */
@@ -35,7 +35,7 @@
 #include <genarch/softint/division.h>
 
-#define ABSVAL(x)  ((x) > 0 ? (x) : -(x))
-#define SGN(x)     ((x) >= 0 ? 1 : 0)
-
+#define ABSVAL(x) ((x) > 0 ? (x) : -(x))
+#define SGN(x) ((x) >= 0 ? 1 : 0)
+				      
 static unsigned int divandmod32(unsigned int a, unsigned int b,
     unsigned int *remainder)
@@ -56,5 +56,5 @@
 		return 0;
 	}
-	
+
 	for (; steps > 0; steps--) {
 		/* shift one bit to remainder */
@@ -68,7 +68,8 @@
 		a <<= 1;
 	}
-	
+
 	return result;
 }
+
 
 static unsigned long long divandmod64(unsigned long long a,
@@ -76,5 +77,5 @@
 {
 	unsigned long long result;
-	int steps = sizeof(unsigned long long) * 8;
+	int steps = sizeof(unsigned long long) * 8; 
 	
 	*remainder = 0;
@@ -90,5 +91,5 @@
 		return 0;
 	}
-	
+
 	for (; steps > 0; steps--) {
 		/* shift one bit to remainder */
@@ -102,29 +103,31 @@
 		a <<= 1;
 	}
-	
+
 	return result;
 }
 
 /* 32bit integer division */
-int __divsi3(int a, int b)
-{
-	unsigned int rem;
-	int result = (int) divandmod32(ABSVAL(a), ABSVAL(b), &rem);
-	
+int __divsi3(int a, int b) 
+{
+	unsigned int rem;
+	int result;
+	
+	result = (int) divandmod32(ABSVAL(a), ABSVAL(b), &rem);
+
 	if (SGN(a) == SGN(b))
 		return result;
-	
 	return -result;
 }
 
 /* 64bit integer division */
-long long __divdi3(long long a, long long b)
+long long __divdi3(long long a, long long b) 
 {
 	unsigned long long rem;
-	long long result = (long long) divandmod64(ABSVAL(a), ABSVAL(b), &rem);
-	
+	long long result;
+	
+	result = (long long) divandmod64(ABSVAL(a), ABSVAL(b), &rem);
+
 	if (SGN(a) == SGN(b))
 		return result;
-	
 	return -result;
 }
@@ -140,5 +143,5 @@
 unsigned long long __udivdi3(unsigned long long a, unsigned long long b)
 {
-	unsigned long long rem;
+	unsigned long long  rem;
 	return divandmod64(a, b, &rem);
 }
@@ -151,6 +154,7 @@
 	
 	/* if divident is negative, remainder must be too */
-	if (!(SGN(a)))
+	if (!(SGN(a))) {
 		return -((int) rem);
+	}
 	
 	return (int) rem;
@@ -158,5 +162,5 @@
 
 /* 64bit remainder of the signed division */
-long long __moddi3(long long a, long long b)
+long long __moddi3(long long a,long  long b)
 {
 	unsigned long long rem;
@@ -164,6 +168,7 @@
 	
 	/* if divident is negative, remainder must be too */
-	if (!(SGN(a)))
+	if (!(SGN(a))) {
 		return -((long long) rem);
+	}
 	
 	return (long long) rem;
@@ -186,38 +191,4 @@
 }
 
-int __divmodsi3(int a, int b, int *c)
-{
-	unsigned int rem;
-	int result = (int) divandmod32(ABSVAL(a), ABSVAL(b), &rem);
-	
-	if (SGN(a) == SGN(b)) {
-		*c = rem;
-		return result;
-	}
-	
-	*c = -rem;
-	return -result;
-}
-
-unsigned int __udivmodsi3(unsigned int a, unsigned int b,
-    unsigned int *c)
-{
-	return divandmod32(a, b, c);
-}
-
-long long __divmoddi3(long long a, long long b, long long *c)
-{
-	unsigned long long rem;
-	long long result = (int) divandmod64(ABSVAL(a), ABSVAL(b), &rem);
-	
-	if (SGN(a) == SGN(b)) {
-		*c = rem;
-		return result;
-	}
-	
-	*c = -rem;
-	return -result;
-}
-
 unsigned long long __udivmoddi3(unsigned long long a, unsigned long long b,
     unsigned long long *c)
Index: kernel/generic/src/lib/str.c
===================================================================
--- kernel/generic/src/lib/str.c	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ kernel/generic/src/lib/str.c	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -111,11 +111,4 @@
 #include <debug.h>
 #include <macros.h>
-
-/** Check the condition if wchar_t is signed */
-#ifdef WCHAR_IS_UNSIGNED
-	#define WCHAR_SIGNED_CHECK(cond)  (true)
-#else
-	#define WCHAR_SIGNED_CHECK(cond)  (cond)
-#endif
 
 /** Byte mask consisting of lowest @n bits (out of 8) */
@@ -213,8 +206,8 @@
  *
  * @return EOK if the character was encoded successfully, EOVERFLOW if there
- *         was not enough space in the output buffer or EINVAL if the character
- *         code was invalid.
- */
-int chr_encode(const wchar_t ch, char *str, size_t *offset, size_t size)
+ *	   was not enough space in the output buffer or EINVAL if the character
+ *	   code was invalid.
+ */
+int chr_encode(wchar_t ch, char *str, size_t *offset, size_t size)
 {
 	if (*offset >= size)
@@ -434,5 +427,5 @@
 bool ascii_check(wchar_t ch)
 {
-	if (WCHAR_SIGNED_CHECK(ch >= 0) && (ch <= 127))
+	if ((ch >= 0) && (ch <= 127))
 		return true;
 	
@@ -447,5 +440,5 @@
 bool chr_check(wchar_t ch)
 {
-	if (WCHAR_SIGNED_CHECK(ch >= 0) && (ch <= 1114111))
+	if ((ch >= 0) && (ch <= 1114111))
 		return true;
 	
Index: tools/autotool.py
===================================================================
--- tools/autotool.py	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ tools/autotool.py	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -49,5 +49,5 @@
 
 PACKAGE_BINUTILS = "usually part of binutils"
-PACKAGE_GCC = "preferably version 4.7.0 or newer"
+PACKAGE_GCC = "preferably version 4.5.1 or newer"
 PACKAGE_CROSS = "use tools/toolchain.sh to build the cross-compiler toolchain"
 
@@ -66,22 +66,9 @@
 
 #define DECLARE_BUILTIN_TYPE(tag, type) \\
-	AUTOTOOL_DECLARE("builtin_size", "", tag, STRING(type), "", "", sizeof(type)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "unsigned long long int", tag, STRING(type), "unsigned", "", __builtin_types_compatible_p(type, unsigned long long int)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "unsigned long int", tag, STRING(type), "unsigned", "", __builtin_types_compatible_p(type, unsigned long int)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "unsigned int", tag, STRING(type), "unsigned", "", __builtin_types_compatible_p(type, unsigned int)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "unsigned short int", tag, STRING(type), "unsigned", "", __builtin_types_compatible_p(type, unsigned short int)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "unsigned char", tag, STRING(type), "unsigned", "", __builtin_types_compatible_p(type, unsigned char)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "signed long long int", tag, STRING(type), "signed", "", __builtin_types_compatible_p(type, signed long long int)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "signed long int", tag, STRING(type), "signed", "", __builtin_types_compatible_p(type, signed long int)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "signed int", tag, STRING(type), "signed", "", __builtin_types_compatible_p(type, signed int)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "signed short int", tag, STRING(type), "signed", "", __builtin_types_compatible_p(type, signed short int)); \\
-	AUTOTOOL_DECLARE("builtin_sign", "signed char", tag, STRING(type), "signed", "", __builtin_types_compatible_p(type, signed char));
+	AUTOTOOL_DECLARE("builtin", "", tag, STRING(type), "", "", sizeof(type));
 
 #define DECLARE_INTSIZE(tag, type, strc, conc) \\
 	AUTOTOOL_DECLARE("intsize", "unsigned", tag, #type, strc, conc, sizeof(unsigned type)); \\
 	AUTOTOOL_DECLARE("intsize", "signed", tag, #type, strc, conc, sizeof(signed type));
-
-#define DECLARE_FLOATSIZE(tag, type) \\
-	AUTOTOOL_DECLARE("floatsize", "", tag, #type, "", "", sizeof(type));
 
 int main(int argc, char *argv[])
@@ -275,5 +262,5 @@
 	return int(value, base)
 
-def probe_compiler(common, intsizes, floatsizes):
+def probe_compiler(common, sizes):
 	"Generate, compile and parse probing source"
 	
@@ -283,9 +270,6 @@
 	outf.write(PROBE_HEAD)
 	
-	for typedef in intsizes:
+	for typedef in sizes:
 		outf.write("\tDECLARE_INTSIZE(\"%s\", %s, %s, %s);\n" % (typedef['tag'], typedef['type'], typedef['strc'], typedef['conc']))
-	
-	for typedef in floatsizes:
-		outf.write("\nDECLARE_FLOATSIZE(\"%s\", %s);\n" % (typedef['tag'], typedef['type']))
 	
 	outf.write(PROBE_TAIL)
@@ -331,8 +315,5 @@
 	signed_concs = {}
 	
-	float_tags = {}
-	
-	builtin_sizes = {}
-	builtin_signs = {}
+	builtins = {}
 	
 	for j in range(len(lines)):
@@ -371,5 +352,5 @@
 						print_error(["Unexpected keyword \"%s\" in \"%s\" on line %s." % (subcategory, PROBE_OUTPUT, j), COMPILER_FAIL])
 				
-				if (category == "floatsize"):
+				if (category == "builtin"):
 					try:
 						value_int = decode_value(value)
@@ -377,30 +358,10 @@
 						print_error(["Integer value expected in \"%s\" on line %s." % (PROBE_OUTPUT, j), COMPILER_FAIL])
 					
-					float_tags[tag] = value_int
-				
-				if (category == "builtin_size"):
-					try:
-						value_int = decode_value(value)
-					except:
-						print_error(["Integer value expected in \"%s\" on line %s." % (PROBE_OUTPUT, j), COMPILER_FAIL])
-					
-					builtin_sizes[tag] = {'name': name, 'value': value_int}
-				
-				if (category == "builtin_sign"):
-					try:
-						value_int = decode_value(value)
-					except:
-						print_error(["Integer value expected in \"%s\" on line %s." % (PROBE_OUTPUT, j), COMPILER_FAIL])
-					
-					if (value_int == 1):
-						if (not tag in builtin_signs):
-							builtin_signs[tag] = strc;
-						elif (builtin_signs[tag] != strc):
-							print_error(["Inconsistent builtin type detection in \"%s\" on line %s." % (PROBE_OUTPUT, j), COMPILER_FAIL])
-	
-	return {'unsigned_sizes': unsigned_sizes, 'signed_sizes': signed_sizes, 'unsigned_tags': unsigned_tags, 'signed_tags': signed_tags, 'unsigned_strcs': unsigned_strcs, 'signed_strcs': signed_strcs, 'unsigned_concs': unsigned_concs, 'signed_concs': signed_concs, 'float_tags': float_tags, 'builtin_sizes': builtin_sizes, 'builtin_signs': builtin_signs}
-
-def detect_sizes(probe, bytes, inttags, floattags):
-	"Detect correct types for fixed-size types"
+					builtins[tag] = {'name': name, 'value': value_int}
+	
+	return {'unsigned_sizes': unsigned_sizes, 'signed_sizes': signed_sizes, 'unsigned_tags': unsigned_tags, 'signed_tags': signed_tags, 'unsigned_strcs': unsigned_strcs, 'signed_strcs': signed_strcs, 'unsigned_concs': unsigned_concs, 'signed_concs': signed_concs, 'builtins': builtins}
+
+def detect_uints(probe, bytes, tags):
+	"Detect correct types for fixed-size integer types"
 	
 	macros = []
@@ -409,25 +370,25 @@
 	for b in bytes:
 		if (not b in probe['unsigned_sizes']):
-			print_error(['Unable to find appropriate unsigned integer type for %u bytes.' % b,
+			print_error(['Unable to find appropriate unsigned integer type for %u bytes' % b,
 			             COMPILER_FAIL])
 		
 		if (not b in probe['signed_sizes']):
-			print_error(['Unable to find appropriate signed integer type for %u bytes.' % b,
+			print_error(['Unable to find appropriate signed integer type for %u bytes' % b,
 			             COMPILER_FAIL])
 		
 		if (not b in probe['unsigned_strcs']):
-			print_error(['Unable to find appropriate unsigned printf formatter for %u bytes.' % b,
+			print_error(['Unable to find appropriate unsigned printf formatter for %u bytes' % b,
 			             COMPILER_FAIL])
 		
 		if (not b in probe['signed_strcs']):
-			print_error(['Unable to find appropriate signed printf formatter for %u bytes.' % b,
+			print_error(['Unable to find appropriate signed printf formatter for %u bytes' % b,
 			             COMPILER_FAIL])
 		
 		if (not b in probe['unsigned_concs']):
-			print_error(['Unable to find appropriate unsigned literal macro for %u bytes.' % b,
+			print_error(['Unable to find appropriate unsigned literal macro for %u bytes' % b,
 			             COMPILER_FAIL])
 		
 		if (not b in probe['signed_concs']):
-			print_error(['Unable to find appropriate signed literal macro for %u bytes.' % b,
+			print_error(['Unable to find appropriate signed literal macro for %u bytes' % b,
 			             COMPILER_FAIL])
 		
@@ -456,8 +417,8 @@
 			macros.append({'oldmacro': "c ## %s" % name, 'newmacro': "INT%u_C(c)" % (b * 8)})
 	
-	for tag in inttags:
+	for tag in tags:
 		newmacro = "U%s" % tag
 		if (not tag in probe['unsigned_tags']):
-			print_error(['Unable to find appropriate size macro for %s.' % newmacro,
+			print_error(['Unable to find appropriate size macro for %s' % newmacro,
 			             COMPILER_FAIL])
 		
@@ -465,8 +426,7 @@
 		macros.append({'oldmacro': "%s_MIN" % oldmacro, 'newmacro': "%s_MIN" % newmacro})
 		macros.append({'oldmacro': "%s_MAX" % oldmacro, 'newmacro': "%s_MAX" % newmacro})
-		macros.append({'oldmacro': "1", 'newmacro': 'U%s_SIZE_%s' % (tag, probe['unsigned_tags'][tag] * 8)})
 		
 		newmacro = tag
-		if (not tag in probe['signed_tags']):
+		if (not tag in probe['unsigned_tags']):
 			print_error(['Unable to find appropriate size macro for %s' % newmacro,
 			             COMPILER_FAIL])
@@ -475,24 +435,8 @@
 		macros.append({'oldmacro': "%s_MIN" % oldmacro, 'newmacro': "%s_MIN" % newmacro})
 		macros.append({'oldmacro': "%s_MAX" % oldmacro, 'newmacro': "%s_MAX" % newmacro})
-		macros.append({'oldmacro': "1", 'newmacro': '%s_SIZE_%s' % (tag, probe['signed_tags'][tag] * 8)})
-	
-	for tag in floattags:
-		if (not tag in probe['float_tags']):
-			print_error(['Unable to find appropriate size macro for %s' % tag,
-			             COMPILER_FAIL])
-		
-		macros.append({'oldmacro': "1", 'newmacro': '%s_SIZE_%s' % (tag, probe['float_tags'][tag] * 8)})
-	
-	if (not 'size' in probe['builtin_signs']):
-		print_error(['Unable to determine whether size_t is signed or unsigned.',
-		             COMPILER_FAIL])
-	
-	if (probe['builtin_signs']['size'] != 'unsigned'):
-		print_error(['The type size_t is not unsigned.',
-		             COMPILER_FAIL])
 	
 	fnd = True
 	
-	if (not 'wchar' in probe['builtin_sizes']):
+	if (not 'wchar' in probe['builtins']):
 		print_warning(['The compiler does not provide the macro __WCHAR_TYPE__',
 		               'for defining the compiler-native type wchar_t. We are',
@@ -501,5 +445,5 @@
 		fnd = False
 	
-	if (probe['builtin_sizes']['wchar']['value'] != 4):
+	if (probe['builtins']['wchar']['value'] != 4):
 		print_warning(['The compiler provided macro __WCHAR_TYPE__ for defining',
 		               'the compiler-native type wchar_t is not compliant with',
@@ -514,16 +458,7 @@
 		macros.append({'oldmacro': "__WCHAR_TYPE__", 'newmacro': "wchar_t"})
 	
-	if (not 'wchar' in probe['builtin_signs']):
-		print_error(['Unable to determine whether wchar_t is signed or unsigned.',
-		             COMPILER_FAIL])
-	
-	if (probe['builtin_signs']['wchar'] == 'unsigned'):
-		macros.append({'oldmacro': "1", 'newmacro': 'WCHAR_IS_UNSIGNED'})
-	if (probe['builtin_signs']['wchar'] == 'signed'):
-		macros.append({'oldmacro': "1", 'newmacro': 'WCHAR_IS_SIGNED'})
-	
 	fnd = True
 	
-	if (not 'wint' in probe['builtin_sizes']):
+	if (not 'wint' in probe['builtins']):
 		print_warning(['The compiler does not provide the macro __WINT_TYPE__',
 		               'for defining the compiler-native type wint_t. We are',
@@ -532,5 +467,5 @@
 		fnd = False
 	
-	if (probe['builtin_sizes']['wint']['value'] != 4):
+	if (probe['builtins']['wint']['value'] != 4):
 		print_warning(['The compiler provided macro __WINT_TYPE__ for defining',
 		               'the compiler-native type wint_t is not compliant with',
@@ -544,13 +479,4 @@
 	else:
 		macros.append({'oldmacro': "__WINT_TYPE__", 'newmacro': "wint_t"})
-	
-	if (not 'wint' in probe['builtin_signs']):
-		print_error(['Unable to determine whether wint_t is signed or unsigned.',
-		             COMPILER_FAIL])
-	
-	if (probe['builtin_signs']['wint'] == 'unsigned'):
-		macros.append({'oldmacro': "1", 'newmacro': 'WINT_IS_UNSIGNED'})
-	if (probe['builtin_signs']['wint'] == 'signed'):
-		macros.append({'oldmacro': "1", 'newmacro': 'WINT_IS_SIGNED'})
 	
 	return {'macros': macros, 'typedefs': typedefs}
@@ -645,5 +571,5 @@
 				
 				if (config['CROSS_TARGET'] == "arm32"):
-					gnu_target = "arm-linux-gnueabi"
+					gnu_target = "arm-linux-gnu"
 				
 				if (config['CROSS_TARGET'] == "ia32"):
@@ -660,5 +586,5 @@
 			if (config['PLATFORM'] == "arm32"):
 				target = config['PLATFORM']
-				gnu_target = "arm-linux-gnueabi"
+				gnu_target = "arm-linux-gnu"
 			
 			if (config['PLATFORM'] == "ia32"):
@@ -743,13 +669,8 @@
 				{'type': 'short int', 'tag': 'SHORT', 'strc': '"h"', 'conc': '"@"'},
 				{'type': 'char', 'tag': 'CHAR', 'strc': '"hh"', 'conc': '"@@"'}
-			],
-			[
-				{'type': 'long double', 'tag': 'LONG_DOUBLE'},
-				{'type': 'double', 'tag': 'DOUBLE'},
-				{'type': 'float', 'tag': 'FLOAT'}
 			]
 		)
 		
-		maps = detect_sizes(probe, [1, 2, 4, 8], ['CHAR', 'SHORT', 'INT', 'LONG', 'LLONG'], ['LONG_DOUBLE', 'DOUBLE', 'FLOAT'])
+		maps = detect_uints(probe, [1, 2, 4, 8], ['CHAR', 'SHORT', 'INT', 'LONG', 'LLONG'])
 		
 	finally:
Index: tools/toolchain.sh
===================================================================
--- tools/toolchain.sh	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ tools/toolchain.sh	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -55,10 +55,12 @@
 BINUTILS_VERSION="2.22"
 BINUTILS_RELEASE=""
-GCC_VERSION="4.7.0"
+GCC_VERSION="4.6.3"
 GDB_VERSION="7.4"
 
 BASEDIR="`pwd`"
 BINUTILS="binutils-${BINUTILS_VERSION}${BINUTILS_RELEASE}.tar.bz2"
-GCC="gcc-${GCC_VERSION}.tar.bz2"
+GCC_CORE="gcc-core-${GCC_VERSION}.tar.bz2"
+GCC_OBJC="gcc-objc-${GCC_VERSION}.tar.bz2"
+GCC_CPP="gcc-g++-${GCC_VERSION}.tar.bz2"
 GDB="gdb-${GDB_VERSION}.tar.bz2"
 
@@ -273,5 +275,7 @@
 	
 	download_fetch "${BINUTILS_SOURCE}" "${BINUTILS}" "ee0f10756c84979622b992a4a61ea3f5"
-	download_fetch "${GCC_SOURCE}" "${GCC}" "2a0f1d99fda235c29d40b561f81d9a77"
+	download_fetch "${GCC_SOURCE}" "${GCC_CORE}" "766091220c6a14fcaa2c06dd573e3758"
+	download_fetch "${GCC_SOURCE}" "${GCC_OBJC}" "48ba23770c34b1cb468f72618b4452c5"
+	download_fetch "${GCC_SOURCE}" "${GCC_CPP}" "37515158a0fb3d0800ec41a08c05e69e"
 	download_fetch "${GDB_SOURCE}" "${GDB}" "95a9a8305fed4d30a30a6dc28ff9d060"
 }
@@ -295,5 +299,7 @@
 	echo ">>> Downloading tarballs"
 	source_check "${BASEDIR}/${BINUTILS}"
-	source_check "${BASEDIR}/${GCC}"
+	source_check "${BASEDIR}/${GCC_CORE}"
+	source_check "${BASEDIR}/${GCC_OBJC}"
+	source_check "${BASEDIR}/${GCC_CPP}"
 	source_check "${BASEDIR}/${GDB}"
 	
@@ -310,5 +316,7 @@
 	
 	unpack_tarball "${BASEDIR}/${BINUTILS}" "binutils"
-	unpack_tarball "${BASEDIR}/${GCC}" "GCC"
+	unpack_tarball "${BASEDIR}/${GCC_CORE}" "GCC Core"
+	unpack_tarball "${BASEDIR}/${GCC_OBJC}" "Objective C"
+	unpack_tarball "${BASEDIR}/${GCC_CPP}" "C++"
 	unpack_tarball "${BASEDIR}/${GDB}" "GDB"
 	
@@ -370,5 +378,5 @@
 	"arm32")
 		prepare
-		build_target "arm32" "arm-linux-gnueabi"
+		build_target "arm32" "arm-linux-gnu"
 		;;
 	"ia32")
@@ -407,5 +415,5 @@
 		prepare
 		build_target "amd64" "amd64-linux-gnu"
-		build_target "arm32" "arm-linux-gnueabi"
+		build_target "arm32" "arm-linux-gnu"
 		build_target "ia32" "i686-pc-linux-gnu"
 		build_target "ia64" "ia64-pc-linux-gnu"
@@ -420,5 +428,5 @@
 		prepare
 		build_target "amd64" "amd64-linux-gnu" &
-		build_target "arm32" "arm-linux-gnueabi" &
+		build_target "arm32" "arm-linux-gnu" &
 		build_target "ia32" "i686-pc-linux-gnu" &
 		build_target "ia64" "ia64-pc-linux-gnu" &
Index: uspace/app/binutils/Makefile
===================================================================
--- uspace/app/binutils/Makefile	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ uspace/app/binutils/Makefile	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -112,5 +112,5 @@
 endif
 ifeq ($(PLATFORM),arm32)
-TARGET = arm-linux-gnueabi
+TARGET = arm-linux-gnu
 endif
 ifeq ($(PLATFORM),ia32)
Index: uspace/app/sbi/src/run_texpr.c
===================================================================
--- uspace/app/sbi/src/run_texpr.c	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ uspace/app/sbi/src/run_texpr.c	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -98,6 +98,6 @@
 {
 	stree_symbol_t *sym;
-	tdata_item_t *targ_i = NULL;
-	tdata_item_t *titem = NULL;;
+	tdata_item_t *targ_i;
+	tdata_item_t *titem;
 	tdata_object_t *tobject;
 	tdata_deleg_t *tdeleg;
@@ -139,4 +139,7 @@
 		return;
 	}
+
+	/* Make compiler happy. */
+	titem = NULL;
 
 	switch (sym->sc) {
@@ -219,5 +222,5 @@
     stree_tindex_t *tindex, tdata_item_t **res)
 {
-	tdata_item_t *base_ti = NULL;
+	tdata_item_t *base_ti;
 	tdata_item_t *titem;
 	tdata_array_t *tarray;
Index: uspace/app/tester/fault/fault2.c
===================================================================
--- uspace/app/tester/fault/fault2.c	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ uspace/app/tester/fault/fault2.c	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -35,6 +35,8 @@
 const char *test_fault2(void)
 {
-	volatile long long var = 0;
-	volatile int var1 = *((aliasing_int *) (((char *) (&var)) + 1));
+	volatile long long var;
+	volatile int var1;
+	
+	var1 = *((aliasing_int *) (((char *) (&var)) + 1));
 	printf("Read %d\n", var1);
 	
Index: uspace/lib/c/arch/arm32/src/eabi.S
===================================================================
--- uspace/lib/c/arch/arm32/src/eabi.S	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ uspace/lib/c/arch/arm32/src/eabi.S	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -1,4 +1,4 @@
 #
-# Copyright (c) 2012 Martin Decky
+# Copyright (c) 2007 Pavel Jancik
 # All rights reserved.
 #
@@ -31,64 +31,5 @@
 .global __aeabi_read_tp
 
-.global __aeabi_idiv
-.global __aeabi_uidiv
-
-.global __aeabi_idivmod
-.global __aeabi_uidivmod
-
-.global __aeabi_ldivmod
-.global __aeabi_uldivmod
-
 __aeabi_read_tp:
 	mov r0, r9
 	mov pc, lr
-
-__aeabi_idiv:
-	push {sp, lr}
-	bl __divsi3
-	ldr lr, [sp, #4]
-	add sp, sp, #8
-	bx lr
-
-__aeabi_uidiv:
-	push {sp, lr}
-	bl __udivsi3
-	ldr lr, [sp, #4]
-	add sp, sp, #8
-	bx lr
-
-__aeabi_idivmod:
-	sub sp, sp, #8
-	push {sp, lr}
-	bl __divmodsi3
-	ldr lr, [sp, #4]
-	add sp, sp, #8
-	pop {r1, r2}
-	bx lr
-
-__aeabi_uidivmod:
-	sub sp, sp, #8
-	push {sp, lr}
-	bl __udivmodsi3
-	ldr lr, [sp, #4]
-	add sp, sp, #8
-	pop {r1, r2}
-	bx lr
-
-__aeabi_ldivmod:
-	sub sp, sp, #8
-	push {sp, lr}
-	bl __divmoddi3
-	ldr lr, [sp, #4]
-	add sp, sp, #8
-	pop {r2, r3}
-	bx lr
-
-__aeabi_uldivmod:
-	sub sp, sp, #8
-	push {sp, lr}
-	bl __udivmoddi3
-	ldr lr, [sp, #4]
-	add sp, sp, #8
-	pop {r2, r3}
-	bx lr
Index: uspace/lib/c/generic/str.c
===================================================================
--- uspace/lib/c/generic/str.c	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ uspace/lib/c/generic/str.c	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -46,11 +46,4 @@
 #include <mem.h>
 #include <str.h>
-
-/** Check the condition if wchar_t is signed */
-#ifdef WCHAR_IS_UNSIGNED
-	#define WCHAR_SIGNED_CHECK(cond)  (true)
-#else
-	#define WCHAR_SIGNED_CHECK(cond)  (cond)
-#endif
 
 /** Byte mask consisting of lowest @n bits (out of 8) */
@@ -406,5 +399,5 @@
 bool ascii_check(wchar_t ch)
 {
-	if (WCHAR_SIGNED_CHECK(ch >= 0) && (ch <= 127))
+	if ((ch >= 0) && (ch <= 127))
 		return true;
 	
@@ -419,5 +412,5 @@
 bool chr_check(wchar_t ch)
 {
-	if (WCHAR_SIGNED_CHECK(ch >= 0) && (ch <= 1114111))
+	if ((ch >= 0) && (ch <= 1114111))
 		return true;
 	
@@ -520,5 +513,4 @@
  * @param count Size of the destination buffer (must be > 0).
  * @param src   Source string.
- *
  */
 void str_cpy(char *dest, size_t size, const char *src)
@@ -553,5 +545,4 @@
  * @param src   Source string.
  * @param n     Maximum number of bytes to read from @a src.
- *
  */
 void str_ncpy(char *dest, size_t size, const char *src, size_t n)
Index: uspace/lib/softfloat/Makefile
===================================================================
--- uspace/lib/softfloat/Makefile	(revision 41455a2252d8399fc1db67b56337cc546b45a936)
+++ uspace/lib/softfloat/Makefile	(revision 6bb169b5888edb060801d4ac1ed89a86670dd67a)
@@ -29,5 +29,5 @@
 
 USPACE_PREFIX = ../..
-EXTRA_CFLAGS = -Iinclude
+EXTRA_CFLAGS = -Iinclude -Iarch/$(UARCH)/include/
 LIBRARY = libsoftfloat
 
